Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
       getService(Components.interfaces.mozIJSSubScriptLoader).
       loadSubScript('chrome://smartbookmarksbar/content/rjlib.js');

var sbbPrefs = Components.classes['@mozilla.org/preferences-service;1']
            		.getService(Components.interfaces.nsIPrefService)
            		.getBranch('extensions.smartbookmarksbar.');
sbbPrefs.QueryInterface(Components.interfaces.nsIPrefBranch2);

function init()
{
	var mouseoverO = document.getElementById('mouseover');
	var mouseoverV = sbbPrefs.getBoolPref('mouseover');
	mouseoverO.checked = mouseoverV;
	
	var hideFoldersNamesO = document.getElementById('hideFoldersNames');
	var hideFoldersNamesV = sbbPrefs.getBoolPref('hideFoldersNames');
	hideFoldersNamesO.checked = hideFoldersNamesV;
	
	var hideNoFaviconNamesO = document.getElementById('hideNoFaviconNames');
	var hideNoFaviconNamesV = sbbPrefs.getBoolPref('hideNoFaviconNames');
	hideNoFaviconNamesO.checked = hideNoFaviconNamesV;
	
	var spacingV = sbbPrefs.getIntPref('spacing');
	document.getElementById('spacing'+spacingV).setAttribute('selected', true);
	
	var autohideBarO = document.getElementById('autohideBar');
	var autohideBarV = sbbPrefs.getBoolPref('autohideBar');
	autohideBarO.checked = autohideBarV;
	
	/* todo var multirowBarO = document.getElementById('multirowBar');
	var multirowBarV = sbbPrefs.getBoolPref('multirowBar');
	multirowBarO.checked = multirowBarV; */
}

function saveChanges()
{
	var change = false;

	// Mouseover	
	change |= saveBoolPref('mouseover');
	
	// Hide Folders	
	change |= saveBoolPref('hideFoldersNames');
	
	// Hide No Favicon Names
	change |= saveBoolPref('hideNoFaviconNames');
	
	// Spacing
	var oldSpacing = sbbPrefs.getIntPref('spacing');
	var newSpacing = rjlib_getRadiogroupValue('spacing');
	if(oldSpacing != newSpacing) {
		sbbPrefs.setIntPref('spacing', newSpacing);
		change = true;
	}

	// Autohide Bar
	change |= saveBoolPref('autohideBar');
	
	// Multi-row Bar
	// todo change |= saveBoolPref('multirowBar');
	
	// Action !
	if(change) {
		sbbPrefs.setBoolPref('updateNeeded', true);
		
		var sbbStringsBundle = document.getElementById('smartbookmarksbar-strings');
		var restartMsg = sbbStringsBundle.getString('restartMessage');
		if(confirm(restartMsg)) { rjlib_restartFirefox(); }
	}
}

function saveBoolPref(prefId)
{
	var change = false;
	var oldValue = sbbPrefs.getBoolPref(prefId);
	var newValue = document.getElementById(prefId).checked;

	if(oldValue != newValue) {
		sbbPrefs.setBoolPref(prefId, newValue);
		change = true;
	}
	
	return change;
}