Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
       getService(Components.interfaces.mozIJSSubScriptLoader).
       loadSubScript('chrome://smartbookmarksbar/content/rjlib.js');

Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
       getService(Components.interfaces.mozIJSSubScriptLoader).
       loadSubScript('chrome://smartbookmarksbar/content/themesMap.js');

var SMART_BOOKMARKS_BAR_VERSION = '1.3.1'; // todo

var smartbookmarksbar = {
	emid: "smartbookmarksbar@remy.juteau",
	prefs: Components.classes['@mozilla.org/preferences-service;1']
							.getService(Components.interfaces.nsIPrefService)
							.getBranch('extensions.smartbookmarksbar.'),
	strings: document.getElementById("smartbookmarksbar-strings"),

	onLoad: function() {
	    // initialization code
	    smartbookmarksbar.initialized = true;
	    
	    this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);

		var updateNeeded = this.prefs.getBoolPref('updateNeeded');
		
		var userChromeCss = rjlib_getChromePath();
		userChromeCss.append('userChrome.css');
		
	    if(this.themeChanged() || updateNeeded || !userChromeCss.exists()) {
	    	this.generateCss();
			rjlib_restartFirefox();
	    }
	    
	    // show prefs if new version
	    if(this.prefs.getCharPref('version') != SMART_BOOKMARKS_BAR_VERSION) {
	    	this.prefs.setCharPref('version', SMART_BOOKMARKS_BAR_VERSION);
	    	var win = window.openDialog('chrome://smartbookmarksbar/content/options.xul', 'smartBookmarksBarOptions', 'chrome,centerscreen');
	    	win.focus();
	    }
	},
	themeChanged: function() {
		var change = false;
		
		var sbbTheme = this.prefs.getCharPref('theme');
	    var ffTheme = rjlib_getFirefoxThemeName();

	    var mappedTheme = SBB_THEMES_MAP[ffTheme];
	    if(mappedTheme) { ffTheme = mappedTheme; }
		
		if(sbbTheme != ffTheme) {
			// todo
			//alert(ffTheme);
			
			this.prefs.setCharPref('theme', ffTheme);
			change = true;
		}
		
		return change;
	},
	generateCss: function() {
		var mouseover = this.prefs.getBoolPref('mouseover');
		var mouseoverStr = 'off';
		if(mouseover) { mouseoverStr = 'on'; }
		
		var hideFoldersNames = this.prefs.getBoolPref('hideFoldersNames');
		var hideFoldersNamesStr = 'off';
		if(hideFoldersNames) { hideFoldersNamesStr = 'on'; }
		
		var hideNoFaviconNames = this.prefs.getBoolPref('hideNoFaviconNames');
		var hideNoFaviconNamesStr = 'off';
		if(hideNoFaviconNames) { hideNoFaviconNamesStr = 'on'; }
		
		var spacing = this.prefs.getIntPref('spacing');
		
		var autohideBar = this.prefs.getBoolPref('autohideBar');
		var autohideBarStr = 'off';
		if(autohideBar) { autohideBarStr = 'on'; }
		
		/* todo var multirowBar = this.prefs.getBoolPref('multirowBar');
		var multirowBarStr = 'off';
		if(multirowBar) { multirowBarStr = 'on'; } */
		
		var theme = this.prefs.getCharPref('theme');
		
		var cssDir = 'chrome://smartbookmarksbar/skin/';
		var namespaceLineStr = '@namespace url("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");';
		var comHeaderStr = '/* Begin - Smart Bookmarks Bar CSS Imports */';
		var comFooterStr = '/* End - Smart Bookmarks Bar CSS Imports */';
		
		var cssImportsStr = '';
		
		cssImportsStr += comHeaderStr+"\n";
		
		// Base
		cssImportsStr += rjlib_generateCssImport(cssDir+'global/base.css');
		
		// Rollover
		cssImportsStr += rjlib_generateCssImport(cssDir+'global/mouseover-'+mouseoverStr+'.css');
		
		// Folders' names hiding
		cssImportsStr += rjlib_generateCssImport(cssDir+'global/hideFoldersNames-'+hideFoldersNamesStr+'.css');
		
		// No Favicon names hiding
		cssImportsStr += rjlib_generateCssImport(cssDir+'global/hideNoFaviconNames-'+hideNoFaviconNamesStr+'.css');
		
		// Spacing
		cssImportsStr += rjlib_generateCssImport(cssDir+'global/spacing-'+spacing+'.css');
		
		// Autohide bar
		cssImportsStr += rjlib_generateCssImport(cssDir+'global/autohideBar-'+autohideBarStr+'.css');
		
		// Multi-row bar
		// todo cssImportsStr += rjlib_generateCssImport(cssDir+'global/multirowBar-'+multirowBarStr+'.css');

		// Theme
		cssImportsStr += rjlib_generateCssImport(cssDir+'themes/'+theme+'.css');
		cssImportsStr += rjlib_generateCssImport(cssDir+'themes/'+theme+'_mouseover-'+mouseoverStr+'.css');
		cssImportsStr += rjlib_generateCssImport(cssDir+'themes/'+theme+'_mouseover-'+mouseoverStr+'_hideNoFaviconNames-'+hideNoFaviconNamesStr+'.css');
		
		cssImportsStr += comFooterStr+"\n\n";

		// Action !
		var userChromeCss = rjlib_getChromePath();
		userChromeCss.append('userChrome.css');
		
		var cssContent = '';
		if(userChromeCss.exists()) {
			cssContent = rjlib_readFile(userChromeCss);
		}
		else {
			// Attention @namespace doit tre plac aprs les imports CSS
			cssImportsStr += namespaceLineStr+"\n\n";
		}
		
		var regex;
		regex = new RegExp(rjlib_despecializeStringToRegexp(comHeaderStr)+'\\s*', 'g');
		cssContent = cssContent.replace(regex, '');
		regex = new RegExp('@import url\\("'+rjlib_despecializeStringToRegexp(cssDir)+'.*?\.css"\\);\\s*', 'g');
		cssContent = cssContent.replace(regex, '');
		regex = new RegExp(rjlib_despecializeStringToRegexp(comFooterStr)+'\\s*', 'g');
		cssContent = cssContent.replace(regex, '');
		
		cssContent = cssImportsStr + cssContent;
		
		rjlib_writeFile(userChromeCss, cssContent);

		this.prefs.setBoolPref('updateNeeded', false);
	}
};

window.addEventListener("load", function(e) { smartbookmarksbar.onLoad(e); }, false);