// Last update : 20070330

function rjlib_restartFirefox() {
  a=Components.interfaces.nsIAppStartup,Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(a).quit(a.eRestart | a.eAttemptQuit);
}

function rjlib_openTabFirefox(url) {
	gBrowser.selectedTab = gBrowser.addTab(url);
}

function rjlib_getExtensionPath(id) {
	var path = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id);
    return path;
}

function rjlib_getChromePath() {
	var path = Components.classes["@mozilla.org/file/directory_service;1"]
					.getService( Components.interfaces.nsIProperties)
					.get("ProfD", Components.interfaces.nsIFile);
	path.append('chrome');
    return path;
}

function rjlib_getFirefoxThemeName()
{
	var prefB = Components.classes["@mozilla.org/preferences-service;1"]
	                        .getService(Components.interfaces.nsIPrefBranch);
	
	return prefB.getCharPref("general.skins.selectedSkin");
}

function rjlib_getContentLoadHref(e) {
	var unsafeWin = e.target.defaultView;
	if (unsafeWin.wrappedJSObject) { unsafeWin = unsafeWin.wrappedJSObject; }
	var unsafeLoc = new XPCNativeWrapper(unsafeWin, "location").location;
	var href = new XPCNativeWrapper(unsafeLoc, "href").href;
	return href;
}

function rjlib_getSelectedTabLocation() {
	return content.location;
}

function rjlib_extractText(startPattern, endPattern, text) {
	var extract = null;
	var iStart = text.indexOf(startPattern);
	if(iStart >= 0) {
		text = text.substring(iStart);
  		var iEnd = text.indexOf(endPattern);
  		if(iEnd >= 0) { extract = text.substring(startPattern.length, iEnd); }
	}
  	return extract;
}

function rjlib_despecializeStringToRegexp(string) {
	var regexpStr = string;
	regexpStr = regexpStr.replace(new RegExp('\\.', 'g'), '\\.');
	regexpStr = regexpStr.replace(new RegExp('\\/', 'g'), '\\/');
	regexpStr = regexpStr.replace(new RegExp('\\(', 'g'), '\\(');
	regexpStr = regexpStr.replace(new RegExp('\\)', 'g'), '\\)');
	regexpStr = regexpStr.replace(new RegExp('\\[', 'g'), '\\[');
	regexpStr = regexpStr.replace(new RegExp('\\]', 'g'), '\\]');
	regexpStr = regexpStr.replace(new RegExp('\\{', 'g'), '\\}');
	regexpStr = regexpStr.replace(new RegExp('\\{', 'g'), '\\}');
	regexpStr = regexpStr.replace(new RegExp('\\*', 'g'), '\\*');
	return regexpStr;
}

function rjlib_xmlAjaxRequest(url, functionToCall) {
	var req = new XMLHttpRequest();
	req.open('GET', url, true);
	req.onreadystatechange = function (aEvt) {
									if (req.readyState == 4) {
										if(req.status == 200) {
											var xml = req.responseXML;
								      		eval(functionToCall+"(xml);");
										}
										else { eval(functionToCall+"(null);"); }
									}
								};
	req.send(null);
}

function rjlib_parseXmlString(xml) {
	var parser = new DOMParser();
	var xmlDocument = parser.parseFromString(xml, "text/xml");
	return xmlDocument;
}

function rjlib_serializeXmlDocument(xmlDocument) {
	var serializer = new XMLSerializer();
	var xml = serializer.serializeToString(xmlDocument);
	return xml;
}

function rjlib_xslTransform(xmlDocument, xslDocument) {
	var processor = new XSLTProcessor();
	processor.importStylesheet(xslDocument);
	var htmlDocument = processor.transformToDocument(xmlDocument);
	return htmlDocument;
}

function rjlib_readFile(filepath) {
	var data = "";
	var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
	                        .createInstance(Components.interfaces.nsIFileInputStream);
	var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
	                        .createInstance(Components.interfaces.nsIScriptableInputStream);
	fstream.init(filepath, -1, 0, 0);
	sstream.init(fstream); 
	
	var str = sstream.read(4096);
	while (str.length > 0) {
	  data += str;
	  str = sstream.read(4096);
	}
	
	sstream.close();
	fstream.close();
	return data;
}

function rjlib_writeFile(filepath, data) {
	// file est un nsIFile, data est une chane de caractres
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
	                         .createInstance(Components.interfaces.nsIFileOutputStream);
	
	// utiliser 0x02 | 0x10 pour ouvrir le fichier en ajout.
	foStream.init(filepath, 0x02 | 0x08 | 0x20, 420, 0); // crire, crer, tronquer
	foStream.write(data, data.length);
	foStream.close();
}

function rjlib_generateCssImport(cssPath) {
	return '@import url("'+cssPath+'");'+"\n";
}

function rjlib_getRadiogroupValue(groupId) {
	var options = document.getElementById(groupId).childNodes;
	var i=0;
	var value;
	while((value==null) && (i<options.length)) {
		if(options[i].selected) {
			value = options[i].value;
		}
		i++;
	}
	
	return value;
}