const bpPrefs = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService)
	.QueryInterface(Components.interfaces.nsIPrefBranch);
const bp_Branch = bpPrefs.getBranch("bp.");

const nsIRDFRemoteDataSource        = Components.interfaces.nsIRDFRemoteDataSource;

var gbpstylesDS = null;


var gbpstylesObserver = {
    onAssert            : function(ds, source, predicate, target){
                            
                          },
    onUnassert          : function(ds, source, predicate, target){
                            
                          },
    onChange            : function(ds, source, predicate, oldTarget, newTarget){
                            
                          },
    onMove              : function(ds, oldSource, newSource, predicate, target){},
    onBeginUpdateBatch  : function(ds){},
    onEndUpdateBatch    : function(ds){}
}


function flock_bpstylesGetDS() {
  var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService().QueryInterface(Components.interfaces.nsIRDFService);
  var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
  var profileDir = dirService.get('ProfD', Components.interfaces.nsILocalFile);


if(!gbpstylesDS) {
    // Create file object in the user's profile path.
    var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(profileDir.path);
    file.append('flock_bppremarkup.rdf');
    if(!file.exists()) 
	{
	file.createUnique(0,0700);
	bpPopulateStyles();
	}
      // Create the datasource and a sequence
      gbpstylesDS = new RDFDataSource('file://'+file.path);
      var root = gbpstylesDS.getNode("urn:flock:bpstyles:styles");
      root.makeSeq();
    }

return gbpstylesDS;
}



function flock_bpstylesSetPathway() {
  var ds = flock_bpstylesGetDS();
  var ui = document.getElementById('markup_list');
  ui.database.AddDataSource(ds.getRawDataSource());
  ui.ref = "urn:flock:bpstyles:styles";
  ui.builder.rebuild();
}

function initbpstyles() {
  var ds = flock_bpstylesGetDS();
    var datasource = ds.getRawDataSource().QueryInterface (nsIRDFRemoteDataSource);
  datasource.AddObserver(gbpstylesObserver);
flock_bpstylesSetPathway();
$$('sidebar-box').width = "260";
}

function _bpstylesmns(str) {
  return "http://www.flock.com/rdf/bpstyles#" + str;
}

function closebpstyles() {
  var ds = flock_bpstylesGetDS();
  var datasource = ds.getRawDataSource().QueryInterface (nsIRDFRemoteDataSource);
  datasource.Flush();
  datasource.RemoveObserver(gbpstylesObserver);
}

function add_bpstylesobject(data){
	try{
	    var ds = flock_bpstylesGetDS();
	    var container = ds.getNode("urn:flock:bpstyles:styles");
	    var date=new Date();

	    var id= data.name + date.getTime();

	    var root = ds.getNode("urn:flock:bpstyles:styles");
	    var node = ds.getNode("urn:flock:bpstyles:styles:" + id);

	    node.addTargetOnce(_bpstylesmns('id'), "urn:flock:bpstyles:styles:" + id );
	    node.addTargetOnce(_bpstylesmns('name'), data.name + "" );
	    node.addTargetOnce(_bpstylesmns('before'), data.before + "");
	    node.addTargetOnce(_bpstylesmns('content'), data.content + "");
	node.addTargetOnce(_bpstylesmns('after'), data.after + "");
	    root.addChild(node);
	    ds.save();
	    
	}
	catch(e){
		
	}
}


function delete_bpstyles() {
  var ds = flock_bpstylesGetDS();
  var container = ds.getNode("urn:flock:bpstyles:styles");
  var tree = $('markup_list');
  var treeSelection = flock_getTreeSelection(tree, ["idCol"]);
  var item = treeSelection[0];
  var rdfId = item["idCol"];
  var node = ds.getNode( rdfId );
  ds.deleteRecursive(node);
  container.removeChild(node);
  ds.save();
}


function applybpStyle(e){
if (e.button == 0){
try{
var deckid = $$('edit-frame').contentWindow.$('editordeck').selectedIndex;
}
catch(err){
var deckid = $$('editordeck').selectedIndex;
}
if (deckid == "1"){
applybpStyleSource();
}
else{
applybpStyleEditor();
}
}
}

function createbpStyle(){
  var params = {
      name: "",
	before: "",
	content: "",
	after: "",
      cancelled: false
    };
    window.openDialog("chrome://blogplus/content/createmarkupDialog.xul", "_blank", "modal,centerscreen", params);
    if (!params.cancelled) {
	var data = {};
	data.name = params.name;	
	data.before = params.before;
	data.content = params.content;	
	data.after = params.after;
  	add_bpstylesobject(data);
    }
}

function editbpStyle(){
  var tree = $('markup_list');
  var treeSelection = flock_getTreeSelection(tree, ["idCol"]);
  var item = treeSelection[0];
  var rdfId = item["idCol"];
  var ds = flock_bpstylesGetDS();
  var node = ds.getNode( rdfId );
  var params = {
      id: rdfId,
      name: node.getTarget(_bpstylesmns('name')).getValue(),
	before: node.getTarget(_bpstylesmns('before')).getValue(),
	content: node.getTarget(_bpstylesmns('content')).getValue(),
	after: node.getTarget(_bpstylesmns('after')).getValue()
      
    };
    window.openDialog("chrome://blogplus/content/markupDialog.xul", "_blank", "modal,centerscreen", params);
    
}

function bpPopulateStyles(){

var data = {};
	data.name = "eg. Big Blue";	
	data.before = '<span style="color: blue; font-size: 14px; font-weight: bold;">';
	data.content = ""	
	data.after = "</span>"
	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. 5px Margin";	
	data.before = '<span style="margin: 5px">';
	data.content = ""	
	data.after = "</span>"
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. Italic Grey";	
	data.before = '<span style="color: #505050; font-style: italic;">';
	data.content = ""	
	data.after = "</span>"
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. signature";	
	data.before = "";	
	data.content = '<p style="font-size:10px;text-align:left;">This is my custom signature!</p>';
	data.after = ""
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. microformat(uF) adr";	
	data.before = '<div class="adr">';	
	data.content = "";
	data.after = "</div>"
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. uF street-adr";	
	data.before = '<div class="street-address">';	
	data.content = "";
	data.after = "</div>"
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. uF locality";	
	data.before = '<span class="locality">';	
	data.content = "";
	data.after = "</span>"
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. uF region";	
	data.before = '<span class="region">';	
	data.content = "";
	data.after = "</span>"
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. uF postal";	
	data.before = '<span class="postal-code">';	
	data.content = "";
	data.after = "</span>"
  	add_bpstylesobject(data); 

var data = {};
	data.name = "eg. uF country";	
	data.before = '<div class="country-name">';	
	data.content = "";
	data.after = "</div>"
  	add_bpstylesobject(data); 

}

function bpclearcontextual(){
try{
var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
var win = wm.getMostRecentWindow('contextual');
if (win)
win.close();
}
catch(err){
}
}

function applybpStyleSource(){
var source = bp$$editsource();
var selstart = source.selectionStart;
var selend = source.selectionEnd;
var text = source.value;
var textend = source.value.length;
var textstart = text.substring(0,selstart)
var textsel = text.substring(selstart,selend);
var wholeend = text.substring(selend,textend);
  var tree = $('markup_list');
  var treeSelection = flock_getTreeSelection(tree, ["idCol"]);
  var item = treeSelection[0];
  var rdfId = item["idCol"];
  var ds = flock_bpstylesGetDS();
  var node = ds.getNode( rdfId );
var objectbefore = node.getTarget(_bpstylesmns('before')).getValue();
var objectcontent = node.getTarget(_bpstylesmns('content')).getValue();
var objectafter = node.getTarget(_bpstylesmns('after')).getValue();
var markup = textstart + objectbefore + objectcontent + textsel + objectafter + wholeend;
source.value = markup;
}

function applybpStyleEditor(){
gNSEditor = bp$$edit().docShell.QueryInterface(Components.interfaces.nsIEditorDocShell);
gNSHTMLEditor = gNSEditor.editor.QueryInterface(Components.interfaces.nsIHTMLEditor);
try{
var text = bpxmlser();
}
catch(err){
var text = "";
}
  var tree = $('markup_list');
  var treeSelection = flock_getTreeSelection(tree, ["idCol"]);
  var item = treeSelection[0];
  var rdfId = item["idCol"];
  var ds = flock_bpstylesGetDS();
  var node = ds.getNode( rdfId );
var objectbefore = node.getTarget(_bpstylesmns('before')).getValue();
var objectcontent = node.getTarget(_bpstylesmns('content')).getValue();
var objectafter = node.getTarget(_bpstylesmns('after')).getValue();
var markup = objectbefore + objectcontent + text + objectafter
if (text == "" && objectcontent == "")
alert('No text selected in Editor');
else
bp$$edit().contentWindow.document.execCommand("inserthtml", false, markup);
}

var gParams;

function bpstylesonLoad() {
  gParams  = window.arguments[0];
$('bpstyles-id').value = gParams.id;
$('bpstyles-name').value = gParams.name;
$('bpstyles-before').value = gParams.before;
$('bpstyles-content').value = gParams.content;
$('bpstyles-after').value = gParams.after;
}


function bpstylesonAccept() {
var rfid = $('bpstyles-id').value;
var ds = flock_bpstylesGetDS();
var node = ds.getNode( rfid );
node.addTargetOnce(_bpstylesmns('name'), $('bpstyles-name').value);
node.addTargetOnce(_bpstylesmns('before'), $('bpstyles-before').value);
node.addTargetOnce(_bpstylesmns('content'), $('bpstyles-content').value);
node.addTargetOnce(_bpstylesmns('after'), $('bpstyles-after').value);
}

function createbpstylesonLoad() {
  gParams  = window.arguments[0];
}

function bponCancel() {
  gParams.cancelled = true;
  return true;
}

function createbpstylesonAccept() {
  gParams.name = $('bpstyles-name').value;
  gParams.before = $('bpstyles-before').value;
  gParams.content = $('bpstyles-content').value;
  gParams.after = $('bpstyles-after').value;
  return true;
}

// ***************************** old flock code **************************888

function flock_getTreeSelection(aTree, aCols, aOpts) {
    XXX('DEPRECATED', 'please use the getSelected method on a flock.xul.Tree instance instead');
    if (!aOpts) aOpts = {};
    var indexList = [];
    
    var rangeMin = {};
    var rangeMax = {};
    aTree.view.selection.getRangeAt(0, rangeMin, rangeMax);
    var out = [];
    var rangeCount = aTree.view.selection.getRangeCount();
    XXX('RANGE INIT', rangeMin.value, rangeMax.value);
    XXX('RANGECOUNT', rangeCount);
    for (var j = 0; j < rangeCount; ++j) {
        var dummy = {};
        aTree.view.selection.getRangeAt(j, dummy, rangeMax);
        XXX('RANGE', rangeMin.value, rangeMax.value);
    }
    XXX('RANGE END', rangeMin.value, rangeMax.value);
    
    for (var i = rangeMin.value; i <= rangeMax.value; ++i) {
        if (!aTree.view.selection.isSelected(i)) continue;
        var rowIndex = i;
        var parentIndex = aTree.view.getParentIndex(i);
        var isContainer = aTree.view.isContainer(i);
        if (aOpts['filterChildren']
            && indexList.indexOf(parentIndex) != -1) {
            continue;
        }
        indexList.push(rowIndex);
        var row = {
            rowIndex: rowIndex, 
            parentIndex: parentIndex, 
            isContainer: isContainer
        };
        
        row["parentIndex"] = aTree.view.getParentIndex(i);
        row["isContainer"] = aTree.view.isContainer(i);
        for (var j = 0; j < aCols.length; ++j) {
            var colName = aCols[j];
            var col = aTree.columns.getNamedColumn(colName);
            row[colName] = aTree.view.getCellText(i, col);
        }
        out.push(row);
    }
    return out;
}


